//--------------------------------------------------------------------------//
// xmtnimage64.cc                                                           //
// Latest revision: 05-22-2001                                              //
// Copyright (C) 2001 by Thomas J. Nelson                                   //
// All rights reserved.                                                     //
//--------------------------------------------------------------------------//

#include "xmtnimage.h"

extern Globals     g;
extern Image      *z;
extern int         ci;
int alter[10];

//-------------------------------------------------------------------------//
// alternate                                                               //
//-------------------------------------------------------------------------//
void alternate(int noofargs, char **arg)
{
  noofargs=noofargs; arg=arg;
  static clickboxinfo* item;
  char temp[100];
  int helptopic = 0;
   
  if(noofargs)
  {    if(noofargs>=1) alter[0] = atoi(arg[1]);
       if(noofargs>=2) alter[1] = atoi(arg[2]);
       if(noofargs>=3) alter[2] = atoi(arg[3]);
       alternate_images();
  }else
  {    item = new clickboxinfo[3];
       item[0].wantpreview=0;
       item[0].title = new char[128];        
       strcpy(item[0].title,"First image");
       item[0].startval = 1;
       item[0].minval = 1;
       item[0].maxval = g.image_count - 1;
       item[0].type = VALSLIDER;
       item[0].wantdragcb = 0;
       item[0].answers = new int[10]; // Must be 10 for multiclickbox cb
       item[0].f1 = null;
       item[0].f2 = null;
       item[0].f3 = null;
       item[0].f4 = null;
       item[0].form = NULL;
       item[0].path = NULL;

       item[1].title = new char[128];        
       strcpy(item[1].title,"Second image");
       item[1].startval = ci;
       item[1].minval = 1;
       item[1].maxval = g.image_count - 1;
       item[1].type = VALSLIDER;
       item[1].wantdragcb = 0;
       item[1].answers = item[0].answers; 
       item[1].f1 = null;
       item[1].f2 = null;
       item[1].f3 = null;
       item[1].f4 = null;
       item[1].f5 = null;
       item[1].f6 = null;
       item[1].f7 = null;
       item[1].f8 = null;
       item[1].form = NULL;
       item[1].path = NULL;

       item[2].title = new char[128];        
       strcpy(item[2].title,"Delay (msec)");
       item[2].startval = 500;
       item[2].minval = 1;
       item[2].maxval = 10000;
       item[2].type = VALSLIDER;
       item[2].wantdragcb = 0;
       item[2].answers = item[0].answers; 
       item[2].f1 = null;
       item[2].f2 = null;
       item[2].f3 = null;
       item[2].f4 = null;
       item[2].f5 = null;
       item[2].f6 = null;
       item[2].f7 = null;
       item[2].f8 = null;
       item[2].form = NULL;
       item[2].path = NULL;

       strcpy(temp,"Alternate two images");
       item[0].ino = ci;
       item[0].noofbuttons = 3;
       item[0].f5 = alternateok;
       item[0].f6 = alternatefinish;
       item[0].f7 = null;
       item[0].f8 = null;
       multiclickbox(temp, 3, item, null, helptopic);
  }
}


//-------------------------------------------------------------------------//
// alternateok                                                             //
//-------------------------------------------------------------------------//
void alternateok(clickboxinfo *c)
{
  alter[0] = c[0].answer;
  alter[1] = c[1].answer;
  alter[2] = c[2].answer;
  alternate_images();
}


//-------------------------------------------------------------------------//
// alternatefinish                                                         //
//-------------------------------------------------------------------------//
void alternatefinish(clickboxinfo *c)
{
   delete[] c[0].title;
   delete[] c[0].answers;
   delete[] c;
}


//--------------------------------------------------------------------------//
// alternate_images                                                         //
//--------------------------------------------------------------------------//
void alternate_images(void)
{
  XtAppAddTimeOut(g.app, alter[2], alternatecb, (XtP)NULL);
}


//--------------------------------------------------------------------------//
// alternatecb                                                              //
//--------------------------------------------------------------------------//
void alternatecb(XtP client_data, XtIntervalId *timer_id)
{  
   static int hit = 0;
   int ino;
   XEvent event;
   client_data = client_data;
   timer_id=timer_id;  // Keep compiler quiet
   if(XCheckMaskEvent(g.display, g.main_mask | g.mouse_mask, &event))
         XtAppProcessEvent(g.app, XtIMAll);
   if(!g.getout)
      XtAppAddTimeOut(XtWidgetToApplicationContext(g.main_widget), alter[2], 
         alternatecb, (XtP)NULL);
   g.getout = 0;
   if(hit) ino = alter[0]; else ino = alter[1];
   if(!between(ino, 1, g.image_count-1)) return;
   if(z[ino].shell) 
      XRaiseWindow(g.display,XtWindow(XtParent(XtParent(z[ino].widget))));
   else
      XRaiseWindow(g.display,z[ino].win);
   hit = 1 - hit;
}

